package tiny

import java.io.FileWriter
import scala.collection.mutable.Map
import scala.sys.process._

/**
 * Wrapper for the assembler and linker.
 * This takes our generated assembly code file, links it with a library
 * for runtime I/O support, and produces a binary machine code file
 * (an executable).
 */
object Link {
  def apply(asm: String, asmpath: String, binfile: String) = {
		println(asmpath)
		val asmfile = new FileWriter(asmpath)
		asmfile.write(asm)
		asmfile.close
		val binfile = "./a.out"
		println(binfile)
		(Seq("gcc", "-m32", "-o", binfile, asmpath, System.getenv("TINY_HOME") + "/runtime/runtime.o") !)
  }
}